<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      is-fixed-header
      @select="onSelection"
      @add="onAdd"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      title="Единица измерения услуги"
      size="medium"
      :titleSecond="newStatus ? 'Добавление' : 'Просмотр'"
      :is-show-pagination="!newStatus"
      :is-show-controls="false"
      @closed="hideViewItemModal"
    >
      <service-unit
        :data-source="selectedData"
        :api="api"
        :isValidCode="isValidCode"
        @delete="onDelete"
        @changeActive="onChangeActive"
        @submit="onSave"
        @refresh="onRefresh"
        @clearCodeValidation="isValidCode = true"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import api from '@/api';
import paging      from '@/mixins/dictionaries/paging';
import itemMixin   from '@/mixins/dictionaries/edit-item';

import SinglePane  from 'common-components/src/obComponents/obSinglePanels';
import ObModal     from 'common-components/src/obComponents/obModal';
import ObTable     from 'common-components/src/obComponents/obTable';
import ServiceUnit from './modal/ServiceUnit';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__services__service_measurement_units';

export default {
  name: 'ServiceMeasurementUnits',
  components: {
    ObModal,
    ObTable,
    SinglePane,
    ServiceUnit
  },
  mixins: [
    paging,
    itemMixin
  ],
  data() {
    return {
      dataGridRefName: 'ServiceMeasurementUnits',
      api: {
        source: '/oboz2-dictionary-service-measurement-units-crud/v1/'
      },
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      isValidCode: true,
    };
  },
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'name'
        },
        {
          title: this.dictionaryRu.columns.denomination,
          key: 'denomination',
          width: '50%'
        },
        {
          title: this.dictionaryRu.columns.code,
          key: 'code',
          html: data => {
            return data.code ? data.code : '—'
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          html: data => {
            return data.is_active
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive;
          }
        },
        {
          title: '',
          key: '',
          isToggleDisabled: true,
          html: () => {
            return `<i class="icon edit"></i>`
          }
        }
      ];
    }
  },
  methods: {
    async onChangeActive($event) {
      try {
        await api.services.changeServiceMeasurementUnitStatus(this.selectedData.uuid, { isActive: $event });
        this.onRefresh();
      } catch (err) {
        console.log(err);
        this.$notification({ type: 'system_notification_error', message: 'Ошибка смены статуса' });
      }
    },

    processingResult(e) {
      this.isValidCode = !(e && e.status === 409);
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

::v-deep {
  tr td:last-child {
    .td-container {
      justify-content: flex-end;
    }

    .icon {
      opacity: 0;
      transition: opacity 0.3s ease-in-out;
    }
  }

  tr:hover td:last-child {
    .icon {
      opacity: 1;
      color: #606266
    }
  }

  // .ob-func-panel__control-dropdown-item:last-child {
  //   display: none;
  // }
}
</style>